#include <avr/io.h>
#include <util/delay.h>
#include <avr/sfr_defs.h>

#include "lcd.h"
#include "usart.h"

#define s_down bit_is_clear(PINB, 1) // Switch Up to B1
#define s_up bit_is_clear(PINB, 2)	
#define s_enter bit_is_clear(PINB, 3)
#define s_clear bit_is_clear(PINB, 4)
#define s_order bit_is_clear(PINB, 5)

void sendorder(char _data)	//Send one byte of Data
 {
 	/* 
		Now send a Packet
		Packet Format is AA<data><data inverse>Z
		total Packet size if 5 bytes.
		*/

		//Stabilize the Tx Module By Sending JUNK data
		UWriteData('J');	//J for junk

		//Send 'A'
		UWriteData('A');

		//Send Another 'A'
		UWriteData('A');

		//Send the data;
		UWriteData(_data);

		//Send inverse of data for error detection purpose
		UWriteData(~_data);

		//End the packet by writing 'Z'
		UWriteData('Z');

		//Wait for some time
		_delay_loop_2(0);
		_delay_loop_2(0);
		_delay_loop_2(0);
		_delay_loop_2(0);
 }
 	

int main()
	{
	//Initialize the USART with Baud rate = 2400bps
	USARTInit(207); // edited by monster brain
	int idle = 1;
	int i=0;  		// dummy variable
	int done=0;		// check the ORDER complete for every item 
	int upd_qty=1;  // quantity update in enter mode
	char temp;		// Temp variable
	int update = 1;	// Update LCD
	char code[10] = { 0x10,0x20,0x30,0x40,0x50,0x60,0x70,0x80,0x90 }; // Code to send to Reciever
	char hotel[35]  = "Wireless Hotel Ordering System    "; // Hotel system name
  	char item[10][16]={"Tea","Coffee","porotta","Chappathi","Chicken Chilli", \
	"Veg Biriyani","Ch. Biriyani","Chicken Fry","Aloo Gobi","--End of Menu---"}; // Food items
	unsigned int item_num[9]={ 0,0,0,0,0,0,0,0,0 } ; // No of items Ordered
	InitLCD(0);		// Initialise LCD without Uline and Blink
	DDRB = DDRB & 0xC1; // Set the pins Port B1 - B5
	
	while(1)
	{	
		/*while(idle)	// Loop for displaying hotel System Name
		{
			LCDClear();
			_delay_ms(50);
			LCDWriteString(hotel);
			LCDGotoXY(0,1);
			LCDWriteString(" Press any key ");
			temp = hotel[0];
			for(i=0;i<34;i++)
			{
				hotel[i] = hotel[i+1];	// Swapping first and previous characters.
			}
			hotel[i-1] = temp;
			_delay_ms(200);
			if(s_up|s_down|s_enter|s_clear|s_order)
			 {
				idle = 0;
				_delay_ms(500);
			 }
		} */

		if(update) // Update LCD only if button is pressed
			{
			done = 0;
			LCDClear();
			_delay_ms(50);
			LCDWriteStringXY(0,0,">");
			LCDWriteString(item[i]);
			LCDWriteString("<");
			LCDWriteStringXY(15,0,"^");
			LCDWriteStringXY(0,1,item[i+1]);
			if(i!=8)
				LCDWriteStringXY(15,1,"V");
			update = 0;
			} // LCD update completed
		if(s_down)
		 {
		  	if(i<8)
			 {
			 	i += 1;
				_delay_ms(200);
				update = 1;
			 }			
		 }
		if(s_up)
		 {
		  	if(i>0) // check if it is top of menu
			 {
			 	i = i -1;
				_delay_ms(200);
			 	update = 1;
			 }
		 }
		if(s_enter)
		 { 		
			while(!done) // check order quantity is done
			{ 	
			if(upd_qty)  // Update LCD if quantity changed
				{
				_delay_ms(400);
				LCDClear();
				LCDGotoXY(0,0);
		 		LCDWriteString("Quantity? -");
	 			LCDGotoXY(13,0);
				LCDWriteInt(item_num[i],2);
				upd_qty=0;
				} // End LCD update
					if(s_up) // increase quantity by 1
						{
						item_num[i]+=1;
						_delay_ms(200);
						upd_qty = 1;
						}
					if(s_down) // decrease quantity by 1
						{
						if(item_num[i]>0)
							item_num[i]-=1;
						_delay_ms(200);
						upd_qty = 1;
						}
					if(s_clear) // clear the order
						{
						done = 1;
						item_num[i] = 0;
						LCDClear();
		   				LCDGotoXY(0,0);
		 				LCDWriteString("Cancelled");
						upd_qty = 1;
						_delay_ms(1000);
						upd_qty = 1;
						update = 1;
						}
					if(s_enter) // order Confirmed
						{	
						done=1;
						LCDClear();
		   				LCDGotoXY(0,0);
		 				LCDWriteString("Done");
						upd_qty = 1;
						_delay_ms(1000);
						update=	1;
						code[i] = code[i] + item_num[i];		
						} // completed the order
			} // while done loop. Quantity order Done.
		} // Enter Menu IF condition
		if(s_order)
		{
			temp = i;
			LCDClear();
		   	LCDGotoXY(0,0);
		 	LCDWriteString("Ordering....");
			for(i=0;i<10;i++)
			 {
			 	sendorder(code[i]);
				_delay_ms(100);
				idle = 1;
			 }
			update = 1;
			i = temp;
		}
	} // the Main Loop
}
